# coding: utf-8

"""
    Billing API

    Billing API allows users to retrieve billing reports and service package details.

    OpenAPI spec version: 1.4.7
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ServicePackageQuota(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'object': 'str',
        'quota': 'int'
    }

    attribute_map = {
        'object': 'object',
        'quota': 'quota'
    }

    def __init__(self, object=None, quota=None):
        """
        ServicePackageQuota - a model defined in Swagger
        """

        self._object = object
        self._quota = quota
        self.discriminator = None

    @property
    def object(self):
        """
        Gets the object of this ServicePackageQuota.
        Always set to 'service-package-quota'.

        :return: The object of this ServicePackageQuota.
        :rtype: str
        """
        return self._object

    @object.setter
    def object(self, object):
        """
        Sets the object of this ServicePackageQuota.
        Always set to 'service-package-quota'.

        :param object: The object of this ServicePackageQuota.
        :type: str
        """
        if object is None:
            raise ValueError("Invalid value for `object`, must not be `None`")
        allowed_values = ["service-package-quota"]
        if object not in allowed_values:
            raise ValueError(
                "Invalid value for `object` ({0}), must be one of {1}"
                .format(object, allowed_values)
            )

        self._object = object

    @property
    def quota(self):
        """
        Gets the quota of this ServicePackageQuota.
        Available quota for the service package.

        :return: The quota of this ServicePackageQuota.
        :rtype: int
        """
        return self._quota

    @quota.setter
    def quota(self, quota):
        """
        Sets the quota of this ServicePackageQuota.
        Available quota for the service package.

        :param quota: The quota of this ServicePackageQuota.
        :type: int
        """
        if quota is None:
            raise ValueError("Invalid value for `quota`, must not be `None`")
        if quota is not None and quota < 0:
            raise ValueError("Invalid value for `quota`, must be a value greater than or equal to `0`")

        self._quota = quota

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ServicePackageQuota):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
