# coding: utf-8

"""
    Device Directory API

    This is the API Documentation for the Device Directory service.

    OpenAPI spec version: 3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class DeviceEventData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'changes': 'dict(str, str)',
        'created_at': 'datetime',
        'data': 'object',
        'date_time': 'datetime',
        'description': 'str',
        'device_id': 'str',
        'etag': 'datetime',
        'event_type': 'str',
        'event_type_category': 'str',
        'event_type_description': 'str',
        'id': 'str',
        'object': 'str',
        'state_change': 'bool'
    }

    attribute_map = {
        'changes': 'changes',
        'created_at': 'created_at',
        'data': 'data',
        'date_time': 'date_time',
        'description': 'description',
        'device_id': 'device_id',
        'etag': 'etag',
        'event_type': 'event_type',
        'event_type_category': 'event_type_category',
        'event_type_description': 'event_type_description',
        'id': 'id',
        'object': 'object',
        'state_change': 'state_change'
    }

    def __init__(self, changes=None, created_at=None, data=None, date_time=None, description=None, device_id=None, etag=None, event_type=None, event_type_category=None, event_type_description=None, id=None, object=None, state_change=None):
        """
        DeviceEventData - a model defined in Swagger
        """

        self._changes = changes
        self._created_at = created_at
        self._data = data
        self._date_time = date_time
        self._description = description
        self._device_id = device_id
        self._etag = etag
        self._event_type = event_type
        self._event_type_category = event_type_category
        self._event_type_description = event_type_description
        self._id = id
        self._object = object
        self._state_change = state_change
        self.discriminator = None

    @property
    def changes(self):
        """
        Gets the changes of this DeviceEventData.
        Additional data relevant to the event.

        :return: The changes of this DeviceEventData.
        :rtype: dict(str, str)
        """
        return self._changes

    @changes.setter
    def changes(self, changes):
        """
        Sets the changes of this DeviceEventData.
        Additional data relevant to the event.

        :param changes: The changes of this DeviceEventData.
        :type: dict(str, str)
        """

        self._changes = changes

    @property
    def created_at(self):
        """
        Gets the created_at of this DeviceEventData.

        :return: The created_at of this DeviceEventData.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """
        Sets the created_at of this DeviceEventData.

        :param created_at: The created_at of this DeviceEventData.
        :type: datetime
        """

        self._created_at = created_at

    @property
    def data(self):
        """
        Gets the data of this DeviceEventData.

        :return: The data of this DeviceEventData.
        :rtype: object
        """
        return self._data

    @data.setter
    def data(self, data):
        """
        Sets the data of this DeviceEventData.

        :param data: The data of this DeviceEventData.
        :type: object
        """

        self._data = data

    @property
    def date_time(self):
        """
        Gets the date_time of this DeviceEventData.

        :return: The date_time of this DeviceEventData.
        :rtype: datetime
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """
        Sets the date_time of this DeviceEventData.

        :param date_time: The date_time of this DeviceEventData.
        :type: datetime
        """
        if date_time is None:
            raise ValueError("Invalid value for `date_time`, must not be `None`")

        self._date_time = date_time

    @property
    def description(self):
        """
        Gets the description of this DeviceEventData.

        :return: The description of this DeviceEventData.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this DeviceEventData.

        :param description: The description of this DeviceEventData.
        :type: str
        """

        self._description = description

    @property
    def device_id(self):
        """
        Gets the device_id of this DeviceEventData.

        :return: The device_id of this DeviceEventData.
        :rtype: str
        """
        return self._device_id

    @device_id.setter
    def device_id(self, device_id):
        """
        Sets the device_id of this DeviceEventData.

        :param device_id: The device_id of this DeviceEventData.
        :type: str
        """

        self._device_id = device_id

    @property
    def etag(self):
        """
        Gets the etag of this DeviceEventData.

        :return: The etag of this DeviceEventData.
        :rtype: datetime
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """
        Sets the etag of this DeviceEventData.

        :param etag: The etag of this DeviceEventData.
        :type: datetime
        """

        self._etag = etag

    @property
    def event_type(self):
        """
        Gets the event_type of this DeviceEventData.
        Event code

        :return: The event_type of this DeviceEventData.
        :rtype: str
        """
        return self._event_type

    @event_type.setter
    def event_type(self, event_type):
        """
        Sets the event_type of this DeviceEventData.
        Event code

        :param event_type: The event_type of this DeviceEventData.
        :type: str
        """
        if event_type is not None and len(event_type) > 100:
            raise ValueError("Invalid value for `event_type`, length must be less than or equal to `100`")

        self._event_type = event_type

    @property
    def event_type_category(self):
        """
        Gets the event_type_category of this DeviceEventData.
        Category code which groups the event type by a summary category.

        :return: The event_type_category of this DeviceEventData.
        :rtype: str
        """
        return self._event_type_category

    @event_type_category.setter
    def event_type_category(self, event_type_category):
        """
        Sets the event_type_category of this DeviceEventData.
        Category code which groups the event type by a summary category.

        :param event_type_category: The event_type_category of this DeviceEventData.
        :type: str
        """

        self._event_type_category = event_type_category

    @property
    def event_type_description(self):
        """
        Gets the event_type_description of this DeviceEventData.
        Generic description of the event

        :return: The event_type_description of this DeviceEventData.
        :rtype: str
        """
        return self._event_type_description

    @event_type_description.setter
    def event_type_description(self, event_type_description):
        """
        Sets the event_type_description of this DeviceEventData.
        Generic description of the event

        :param event_type_description: The event_type_description of this DeviceEventData.
        :type: str
        """

        self._event_type_description = event_type_description

    @property
    def id(self):
        """
        Gets the id of this DeviceEventData.

        :return: The id of this DeviceEventData.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this DeviceEventData.

        :param id: The id of this DeviceEventData.
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")

        self._id = id

    @property
    def object(self):
        """
        Gets the object of this DeviceEventData.
        The API resource entity.

        :return: The object of this DeviceEventData.
        :rtype: str
        """
        return self._object

    @object.setter
    def object(self, object):
        """
        Sets the object of this DeviceEventData.
        The API resource entity.

        :param object: The object of this DeviceEventData.
        :type: str
        """

        self._object = object

    @property
    def state_change(self):
        """
        Gets the state_change of this DeviceEventData.

        :return: The state_change of this DeviceEventData.
        :rtype: bool
        """
        return self._state_change

    @state_change.setter
    def state_change(self, state_change):
        """
        Sets the state_change of this DeviceEventData.

        :param state_change: The state_change of this DeviceEventData.
        :type: bool
        """

        self._state_change = state_change

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, DeviceEventData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
