# coding: utf-8

"""
    Account Management API

    API for managing accounts, users, creating API keys, uploading trusted certificates

    OpenAPI spec version: v3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class UserInvitationResp(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'account_id': 'str',
        'created_at': 'datetime',
        'email': 'str',
        'etag': 'str',
        'expiration': 'datetime',
        'groups': 'list[str]',
        'id': 'str',
        'object': 'str',
        'updated_at': 'datetime',
        'user_id': 'str'
    }

    attribute_map = {
        'account_id': 'account_id',
        'created_at': 'created_at',
        'email': 'email',
        'etag': 'etag',
        'expiration': 'expiration',
        'groups': 'groups',
        'id': 'id',
        'object': 'object',
        'updated_at': 'updated_at',
        'user_id': 'user_id'
    }

    def __init__(self, account_id=None, created_at=None, email=None, etag=None, expiration=None, groups=None, id=None, object=None, updated_at=None, user_id=None):
        """
        UserInvitationResp - a model defined in Swagger
        """

        self._account_id = account_id
        self._created_at = created_at
        self._email = email
        self._etag = etag
        self._expiration = expiration
        self._groups = groups
        self._id = id
        self._object = object
        self._updated_at = updated_at
        self._user_id = user_id
        self.discriminator = None

    @property
    def account_id(self):
        """
        Gets the account_id of this UserInvitationResp.
        The UUID of the account the user is invited to.

        :return: The account_id of this UserInvitationResp.
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """
        Sets the account_id of this UserInvitationResp.
        The UUID of the account the user is invited to.

        :param account_id: The account_id of this UserInvitationResp.
        :type: str
        """
        if account_id is None:
            raise ValueError("Invalid value for `account_id`, must not be `None`")

        self._account_id = account_id

    @property
    def created_at(self):
        """
        Gets the created_at of this UserInvitationResp.
        Creation UTC time RFC3339.

        :return: The created_at of this UserInvitationResp.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """
        Sets the created_at of this UserInvitationResp.
        Creation UTC time RFC3339.

        :param created_at: The created_at of this UserInvitationResp.
        :type: datetime
        """
        if created_at is None:
            raise ValueError("Invalid value for `created_at`, must not be `None`")

        self._created_at = created_at

    @property
    def email(self):
        """
        Gets the email of this UserInvitationResp.
        Email address of the invited user.

        :return: The email of this UserInvitationResp.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """
        Sets the email of this UserInvitationResp.
        Email address of the invited user.

        :param email: The email of this UserInvitationResp.
        :type: str
        """
        if email is None:
            raise ValueError("Invalid value for `email`, must not be `None`")

        self._email = email

    @property
    def etag(self):
        """
        Gets the etag of this UserInvitationResp.
        API resource entity version.

        :return: The etag of this UserInvitationResp.
        :rtype: str
        """
        return self._etag

    @etag.setter
    def etag(self, etag):
        """
        Sets the etag of this UserInvitationResp.
        API resource entity version.

        :param etag: The etag of this UserInvitationResp.
        :type: str
        """
        if etag is None:
            raise ValueError("Invalid value for `etag`, must not be `None`")

        self._etag = etag

    @property
    def expiration(self):
        """
        Gets the expiration of this UserInvitationResp.
        Invitation expiration as UTC time RFC3339.

        :return: The expiration of this UserInvitationResp.
        :rtype: datetime
        """
        return self._expiration

    @expiration.setter
    def expiration(self, expiration):
        """
        Sets the expiration of this UserInvitationResp.
        Invitation expiration as UTC time RFC3339.

        :param expiration: The expiration of this UserInvitationResp.
        :type: datetime
        """

        self._expiration = expiration

    @property
    def groups(self):
        """
        Gets the groups of this UserInvitationResp.
        A list of IDs of the groups the user is invited to.

        :return: The groups of this UserInvitationResp.
        :rtype: list[str]
        """
        return self._groups

    @groups.setter
    def groups(self, groups):
        """
        Sets the groups of this UserInvitationResp.
        A list of IDs of the groups the user is invited to.

        :param groups: The groups of this UserInvitationResp.
        :type: list[str]
        """

        self._groups = groups

    @property
    def id(self):
        """
        Gets the id of this UserInvitationResp.
        The UUID of the invitation.

        :return: The id of this UserInvitationResp.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this UserInvitationResp.
        The UUID of the invitation.

        :param id: The id of this UserInvitationResp.
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")

        self._id = id

    @property
    def object(self):
        """
        Gets the object of this UserInvitationResp.
        Entity name: always 'user-invitation'

        :return: The object of this UserInvitationResp.
        :rtype: str
        """
        return self._object

    @object.setter
    def object(self, object):
        """
        Sets the object of this UserInvitationResp.
        Entity name: always 'user-invitation'

        :param object: The object of this UserInvitationResp.
        :type: str
        """
        if object is None:
            raise ValueError("Invalid value for `object`, must not be `None`")
        allowed_values = ["user-invitation"]
        if object not in allowed_values:
            raise ValueError(
                "Invalid value for `object` ({0}), must be one of {1}"
                .format(object, allowed_values)
            )

        self._object = object

    @property
    def updated_at(self):
        """
        Gets the updated_at of this UserInvitationResp.
        Last update UTC time RFC3339.

        :return: The updated_at of this UserInvitationResp.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """
        Sets the updated_at of this UserInvitationResp.
        Last update UTC time RFC3339.

        :param updated_at: The updated_at of this UserInvitationResp.
        :type: datetime
        """

        self._updated_at = updated_at

    @property
    def user_id(self):
        """
        Gets the user_id of this UserInvitationResp.
        The UUID of the invited user.

        :return: The user_id of this UserInvitationResp.
        :rtype: str
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """
        Sets the user_id of this UserInvitationResp.
        The UUID of the invited user.

        :param user_id: The user_id of this UserInvitationResp.
        :type: str
        """
        if user_id is None:
            raise ValueError("Invalid value for `user_id`, must not be `None`")

        self._user_id = user_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, UserInvitationResp):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
