# Metric

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**bootstraps_failed** | **int** | The number of failed bootstraps the account has performed. Bootstrap is the process of provisioning a Lightweight Machine to Machine Client to a state where it can initiate a management session to a new Lightweight Machine to Machine Server. | [optional] 
**bootstraps_pending** | **int** | The number of pending bootstraps the account has performed. Bootstrap is the process of provisioning a Lightweight Machine to Machine Client to a state where it can initiate a management session to a new Lightweight Machine to Machine Server. | [optional] 
**bootstraps_successful** | **int** | The number of successful bootstraps the account has performed. Bootstrap is the process of provisioning a Lightweight Machine to Machine Client to a state where it can initiate a management session to a new Lightweight Machine to Machine Server. | [optional] 
**connect_rest_api_error** | **int** | The number of failed [Connect API](/docs/current/service-api-references/connect-api.html) requests the account has performed.The metric do not consider the actual response from the device and it includes only the result of the HTTP request used to subscibe to the device resources. | [optional] 
**connect_rest_api_success** | **int** | The number of successful [Connect API](/docs/current/service-api-references/connect-api.html) requests the account has performed. The metric do not consider the actual response from the device and it includes only the result of the HTTP request used to subscibe to the device resources. | [optional] 
**deleted_registrations** | **int** | The number of deleted registrations (deregistrations) linked to the account. Deregistration is the process of removing the device registration from the Device Management Connect registry. The deregistration is usually initiated by the device. Device Management Connect no longer handles requests for a deregistered device. | [optional] 
**device_observations** | **int** | **(Beta)** The number of observations received by Device Management Connect from the devices linked to the account. The observations are pushed from the device to Device Management Connect when you have successfully subscribed to the device resources using [Connect API](/docs/current/service-api-references/mbed-cloud-connect.html) endpoints.  | [optional] 
**device_proxy_request_error** | **int** | **(Beta)** The number of failed proxy requests from Device Management Connect to devices linked to the account. The proxy requests are made from Mbed Cloud Connect to devices when you try to read or write values to device resources using [Connect API](/docs/current/service-api-references/mbed-cloud-connect.html) endpoints.  | [optional] 
**device_proxy_request_success** | **int** | **(Beta)** The number of successful proxy requests from Device Management Connect to devices linked to the account. The proxy requests are made from Mbed Cloud Connect to devices when you try to read or write values to device resources using [Connect API](/docs/current/service-api-references/mbed-cloud-connect.html) endpoints.  | [optional] 
**device_subscription_request_error** | **int** | **(Beta)** The number of failed subscription requests from Device Management Connect to devices linked to the account. The subscription requests are made from Device Management Connect to devices when you try to subscribe to a resource path using [Connect API](/docs/current/service-api-references/mbed-cloud-connect.html) endpoints.  | [optional] 
**device_subscription_request_success** | **int** | **(Beta)** The number of successful subscription requests from Device Management Connect to devices linked to the account. The subscription requests are made from Device Management Connect to devices when you try to subscribe to a resource path using [Connect API](/docs/current/service-api-references/mbed-cloud-connect.html) endpoints.  | [optional] 
**expired_registrations** | **int** | The number of expired registrations linked to the account. Device Management Connect removes the device registrations when the devices cannot update their registration before the expiry of the lifetime. Device Management Connect no longer handles requests for a device whose registration has expired already. | [optional] 
**full_registrations** | **int** | The number of full registrations linked to the account. Full registration is the process of registering a device with Device Management Connect by providing its lifetime and capabilities such as the resource structure.The registered status of the device does not guarantee that the device is active and accessible from Device Management Connect at any point of time. | [optional] 
**handshakes_successful** | **int** | The number of successful TLS handshakes the account has performed. The SSL or TLS handshake enables the SSL or TLS client and server to establish the secret keys with which they communicate. A successful TLS handshake is required for establishing a connection with Device Management Connect for any operaton such as registration, registration update and deregistration. | [optional] 
**id** | **str** | A unique metric ID. | [optional] 
**registration_updates** | **int** | The number of registration updates linked to the account. Registration update is the process of updating the registration status with Device Management Connect to update or extend the lifetime of the device. | [optional] 
**timestamp** | **datetime** | UTC time in RFC3339 format. The timestamp is the starting point of the interval for which the data is aggregated. Each interval includes data for the time greater than or equal to the timestamp and less than the next interval&#39;s starting point. | [optional] 
**transactions** | **int** | The number of transaction events from or to devices linked to the account. A transaction is a 512-byte block of data processed by Device Management. It can be either sent by the device (device --&gt; mbed cloud) or received by the device (Device Management --&gt; device). A transaction does not include IP, TCP or UDP, TLS or DTLS packet overhead. It only contains the packet payload (full CoAP packet including CoAP headers). | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


