# coding: utf-8

"""
    Update Service API

    This is the API documentation for the Device Management deployment service, which is part of the Update service.

    OpenAPI spec version: 3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class CampaignMetrics(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'created_at': 'datetime',
        'failed_count': 'int',
        'object': 'str',
        'pending_count': 'int',
        'success_count': 'int',
        'total_count': 'int'
    }

    attribute_map = {
        'created_at': 'created_at',
        'failed_count': 'failed_count',
        'object': 'object',
        'pending_count': 'pending_count',
        'success_count': 'success_count',
        'total_count': 'total_count'
    }

    def __init__(self, created_at=None, failed_count=None, object=None, pending_count=None, success_count=None, total_count=None):
        """
        CampaignMetrics - a model defined in Swagger
        """

        self._created_at = created_at
        self._failed_count = failed_count
        self._object = object
        self._pending_count = pending_count
        self._success_count = success_count
        self._total_count = total_count
        self.discriminator = None

    @property
    def created_at(self):
        """
        Gets the created_at of this CampaignMetrics.
        The time the metrics were created.

        :return: The created_at of this CampaignMetrics.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """
        Sets the created_at of this CampaignMetrics.
        The time the metrics were created.

        :param created_at: The created_at of this CampaignMetrics.
        :type: datetime
        """

        self._created_at = created_at

    @property
    def failed_count(self):
        """
        Gets the failed_count of this CampaignMetrics.
        Running total of devices that could not be updated.

        :return: The failed_count of this CampaignMetrics.
        :rtype: int
        """
        return self._failed_count

    @failed_count.setter
    def failed_count(self, failed_count):
        """
        Sets the failed_count of this CampaignMetrics.
        Running total of devices that could not be updated.

        :param failed_count: The failed_count of this CampaignMetrics.
        :type: int
        """

        self._failed_count = failed_count

    @property
    def object(self):
        """
        Gets the object of this CampaignMetrics.
        Entity name: always 'update-campaign-metrics'

        :return: The object of this CampaignMetrics.
        :rtype: str
        """
        return self._object

    @object.setter
    def object(self, object):
        """
        Sets the object of this CampaignMetrics.
        Entity name: always 'update-campaign-metrics'

        :param object: The object of this CampaignMetrics.
        :type: str
        """

        self._object = object

    @property
    def pending_count(self):
        """
        Gets the pending_count of this CampaignMetrics.
        Running total of devices that have yet to receive an update or are applying an update.

        :return: The pending_count of this CampaignMetrics.
        :rtype: int
        """
        return self._pending_count

    @pending_count.setter
    def pending_count(self, pending_count):
        """
        Sets the pending_count of this CampaignMetrics.
        Running total of devices that have yet to receive an update or are applying an update.

        :param pending_count: The pending_count of this CampaignMetrics.
        :type: int
        """

        self._pending_count = pending_count

    @property
    def success_count(self):
        """
        Gets the success_count of this CampaignMetrics.
        Running total of successfully updated devices.

        :return: The success_count of this CampaignMetrics.
        :rtype: int
        """
        return self._success_count

    @success_count.setter
    def success_count(self, success_count):
        """
        Sets the success_count of this CampaignMetrics.
        Running total of successfully updated devices.

        :param success_count: The success_count of this CampaignMetrics.
        :type: int
        """

        self._success_count = success_count

    @property
    def total_count(self):
        """
        Gets the total_count of this CampaignMetrics.
        Number of devices in the campaign.

        :return: The total_count of this CampaignMetrics.
        :rtype: int
        """
        return self._total_count

    @total_count.setter
    def total_count(self, total_count):
        """
        Sets the total_count of this CampaignMetrics.
        Number of devices in the campaign.

        :param total_count: The total_count of this CampaignMetrics.
        :type: int
        """

        self._total_count = total_count

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, CampaignMetrics):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
